<?
/*
#============================================================================
# Program: Devices-Graph.php
# Programmer: Remo Rickli
#
# DATE		COMMENT
# -----------------------------------------------------------
# 27/03/06	initial version.
# 15/05/06	new concept towards CPU and Mem graphing
# 02/11/06	cosmetic changes
# 08/11/06	medium graph option
# 05/03/07	support for 8  stacks
# 25/05/07	Minor Improvements, fixed urlencoding (let me know, if you still find non working ones!)
# 30/08/07	implemented CSS scheme
# 20/09/07	implemented language support
*/

$calendar= 1;

include_once ("inc/header.php");

$_GET = sanitize($_GET);
$dv = isset($_GET['dv']) ? $_GET['dv'] : "";
$if = isset($_GET['if']) ? $_GET['if'] : array();
$cpu = isset($_GET['cpu']) ? $_GET['cpu'] : "";
$mem = isset($_GET['mem']) ? $_GET['mem'] : "";
$tmp = isset($_GET['tmp']) ? $_GET['tmp'] : "";
$cuv = isset($_GET['cuv']) ? $_GET['cuv'] : "";
$sze = isset($_GET['sze']) ? $_GET['sze'] : "5";
$sho = isset($_GET['sho']) ? 1 : 0;
$cad = isset($_GET['cad']) ? 1 : 0;
$tem = isset($_GET['tem']) ? $_GET['tem'] : 2;
$strsta = isset($_GET['sta']) ? $_GET['sta'] : date("m/d/Y H:i", time() - $rrdstep * 800);
$strend = isset($_GET['end']) ? $_GET['end'] : date("m/d/Y H:i");
$sta = strtotime($strsta);
$end = strtotime($strend);
?>
<h1>Device <?=$gralbl?></h1>
<form method="get" action="<?=$self?>.php" name="graf">
<table class="content">
<tr class="<?=$modgroup[$self]?>1">
<th width=80><a href="<?=$self?>.php"><img src="img/32/<?=$selfi?>.png"></a></th>
<th>
<select size=6 name="dv" onchange="this.form.submit();">
<?
$link	= @DbConnect($dbhost,$dbuser,$dbpass,$dbname);
$query	= GenQuery('devices','s','name,ip,snmpversion,community,temp,cuslabel,cusvalue,flags','name');
$res	= @DbQuery($query,$link);
if($res){
	echo "<option value=\"Totals\"".(($dv == "Totals")?" selected":"")."> Network Totals";
	while( ($d = @DbFetchRow($res)) ){
		echo "<option value=\"$d[0]\"";
		if($dv == $d[0]){
			echo " selected";
			$ip = long2ip($d[1]);
			$sp = ($d[2] & 127);
			$hc = ($d[2] & 128);
			$co = $d[3];
			$te = $d[4];
			$cg =$d[5];
			if($cg){
				list($ct,$cy,$cu) = split(";", $d[5]);
			}else{
				$ct = "Mem IO";
				$cu = "Bytes free";
			}
			$cv = $d[6];
			$fl = $d[7];
		}
		echo " >$d[0]\n";
	}
	@DbFreeResult($res);
}else{
	print @DbError($link);
}
?>
</select>
<select multiple size=6 name="if[]">
<?
if ($dv == "Totals") {
?>
<OPTION VALUE="mon"<?=(in_array("mon",$if))?" selected":"";?>> Device <?=$avalbl?>
<OPTION VALUE="msg"<?=(in_array("msg",$if))?" selected":"";?>> <?=$msglbl?>
<OPTION VALUE="nod"<?=(in_array("nod",$if))?" selected":"";?>> Total Nodes
<OPTION VALUE="tpw"<?=(in_array("tpw",$if))?" selected":"";?>> Total PoE
<OPTION VALUE="ttr"<?=(in_array("ttr",$if))?" selected":"";?>> Edge <?=$trflbl?>
<OPTION VALUE="ter"<?=(in_array("ter",$if))?" selected":"";?>> (Non Wlan) <?=$errlbl?>
<OPTION VALUE="tdi"<?=(in_array("tdi",$if))?" selected":"";?>> Disabled Interfaces
<?
}elseif ($dv) {
	$query	= GenQuery('interfaces','s','ifname,alias,comment','ifidx','',array('device'),array('='),array($dv) );
	$res	= @DbQuery($query,$link);
	if($res){
		while( ($i = @DbFetchRow($res)) ){
			echo "<OPTION VALUE=\"$i[0]\" ";
			if(in_array($i[0],$if)){echo "selected";}
			echo " >$i[0] " . substr("$i[1] $i[2]\n",0,30);
		}
		@DbFreeResult($res);
	}
	$ud = rawurlencode($dv);
}
?>
</select>
</th>
<td>
<INPUT type="checkbox" name="cpu" <?=($cpu)?"checked":""?> > CPU<br>
<INPUT type="checkbox" name="mem" <?=($mem)?"checked":""?> > Mem<br>
<?
if($te){
?>
<INPUT type="checkbox" name="tmp" <?=($tmp)?"checked":""?> > <?=$tmplbl?><br>
<?
}
if($cv or $cg){
?>
<INPUT type="checkbox" name="cuv" <?=($cuv)?"checked":""?> > <?=($ct)?><br>
<?
}
?>
</td>
<th>
<p><img src="img/16/blft.png" title="<?=$fislbl?>"><a href="javascript:show_calendar('graf.sta');"><img src="img/16/date.png"></a>
<input type="text" name="sta" value="<?=$strsta?>" size="15">
<p><img src="img/16/brgt.png" title="<?=$laslbl?>"><a href="javascript:show_calendar('graf.end');"><img src="img/16/date.png"></a>
<input type="text" name="end" value="<?=$strend?>" size="15">
</th>
<?if($cacticli){?>
<td align="center"><h3>Cacti</h3>
<input type="radio" name="tem" value="2" <?=($tem == 2)?"checked":""?>><?=$trflbl?>
<input type="radio" name="tem" value="22" <?=($tem == 22)?"checked":""?>><?=$errlbl?>
<input type="radio" name="tem" value="24" <?=($tem == 24)?"checked":""?>>Broadcast<p>
<input type="submit" name="cad" value="<?=$addbtn?>">
</td>
<?}?>
<th width=80>
<SELECT size=1 name="sze">
<OPTION VALUE=""><?=$siz['x']?>
<OPTION VALUE="4" <?=($sze == "4")?"selected":""?> ><?=$siz['l']?>
<OPTION VALUE="3" <?=($sze == "3")?"selected":""?> ><?=$siz['m']?>
<OPTION VALUE="2" <?=($sze == "2")?"selected":""?> ><?=$siz['s']?>
</SELECT>
<p>
<input type="submit" name="sho" value="<?=$shobtn?>">
</th>
</tr></table></form>
<div align="center"><p>
<?
if($dv){echo "<h2>$dv</h2>";}
if($sta > $end){
	echo "<h4>$fislbl > $laslbl</h4>";
}elseif($cad){
	$adev = exec("$cacticli/add_device.php --description=\"$dv\" --ip=\"$ip\" --template=1 --version=\"$sp\" --community=\"$co\"");
	echo "<div class=\"textpad code txta\">$adev</div>";
	flush();
	$devid = preg_replace("/.*device-id: \((\d+)\).*/","$1",$adev);
	if($devid){
		if($tem == 22){
			$qtyp = 2;
		}elseif($tem == 24){
			$qtyp = 3;
		}elseif($hc){
			$qtyp = 14;
		}else{
			$qtyp = 13;
		}
		foreach ($if as $i){
			$agrf = exec("$cacticli/add_graphs.php --graph-type=ds --graph-template-id=$tem --host-id=$devid --snmp-query-id=1 --snmp-query-type-id=$qtyp --snmp-field=ifName --snmp-value=\"$i\"");
			echo "<div class=\"textpad code txtb\">$agrf</div>";
			flush();
		}
	}
}elseif ($dv == "Totals") {
	echo ( in_array("mon",$if) )?"<img src=\"inc/drawrrd.php?&s=$sze&t=mon&a=$sta&e=$end\" title=\"Device $avalbl\">\n":"";
	echo ( in_array("msg",$if) )?"<img src=\"inc/drawrrd.php?&s=$sze&t=msg&a=$sta&e=$end\" title=\"$msglbl\">\n":"";
	echo ( in_array("nod",$if) )?"<img src=\"inc/drawrrd.php?&s=$sze&t=nod&a=$sta&e=$end\" title=\"Total Nodes\">\n":"";
	echo ( in_array("tpw",$if) )?"<img src=\"inc/drawrrd.php?&s=$sze&t=tpw&a=$sta&e=$end\" title=\"Total PoE\">\n":"";
	echo ( in_array("ttr",$if) )?"<img src=\"inc/drawrrd.php?&s=$sze&t=ttr&a=$sta&e=$end\" title=\"$trflbl\">\n":"";
	echo ( in_array("ter",$if) )?"<img src=\"inc/drawrrd.php?&s=$sze&t=ter&a=$sta&e=$end\" title=\"Device $errlbl\">\n":"";
	echo ( in_array("tdi",$if) )?"<img src=\"inc/drawrrd.php?&s=$sze&t=tdi&a=$sta&e=$end\" title=\"Disabled Interfaces\">\n":"";
}else{
	echo ($cpu)?"<img src=\"inc/drawrrd.php?dv=$ud&s=$sze&t=cpu&a=$sta&e=$end\" title=\"% CPU\">\n":"";
	echo ($mem)?"<img src=\"inc/drawrrd.php?dv=$ud&s=$sze&t=mem&a=$sta&e=$end\" title=\"$avalbl\">\n":"";
	echo ($tmp)?"<img src=\"inc/drawrrd.php?dv=$ud&s=$sze&t=tmp&a=$sta&e=$end\" title=\"Temp\">\n":"";
	echo ($cuv)?"<img src=\"inc/drawrrd.php?dv=$ud&&if[]=".urlencode($ct)."&if[]=".urlencode($cu)."&s=$sze&t=cuv&a=$sta&e=$end\" title=\"$ct [$cu]\">\n":"";
	if( isset($if[0]) ){
		$ifs = "";
		foreach ( $if as $i){
			$ifs .= '&if[]='.rawurlencode($i);
		}
		echo "<img src=inc/drawrrd.php?dv=$ud$ifs&s=$sze&t=trf&a=$sta&e=$end>\n";
		echo "<img src=inc/drawrrd.php?dv=$ud$ifs&s=$sze&t=err&a=$sta&e=$end>\n";
		if($fl & 1){echo "<img src=inc/drawrrd.php?dv=$ud$ifs&s=$sze&t=brc&a=$sta&e=$end>\n";}
	}
}
?>
</div>
<?
include_once ("inc/footer.php");
?>
