<?

/*
#============================================================================
# Program: Devices-Stock.php
# Programmer: Remo Rickli
#
# DATE		COMMENT
# -------- ------------------------------------------------------------------
# 22/02/05	initial version.
# 04/03/05	revised backend
# 10/03/05	revised authentication
# 07/03/06	renamed time field, added icons
# 17/03/06	new SQL query support
# 05/03/07	location field
# 04/09/07	implemented CSS scheme, adjusted layout
# 20/09/07	implemented language support
# 12/09/08	played with barcode flash plugin for webcams (gave up):
# <embed src="http://en.barcodepedia.com/swf/scanner.swf" flashvars="baseUrl=http://www.google.com/search?q=&e1=Flash+8+required.&e2=No+webcam+found.&e3=Access+to+webcam+disallowed+by+user." width="320" height="240"> 
*/

$calendar= 1;

$cico['10']  = "star";
$cico['100'] = "flas";
$cico['150'] = "warn";
$cico['200'] = "bstp";

include_once ("inc/header.php");
include_once ('inc/libdev.php');
$_GET = sanitize($_GET);
$chg = isset($_GET['chg']) ? $_GET['chg'] : "";
$add = isset($_GET['add']) ? $_GET['add'] : "";
$upd = isset($_GET['upd']) ? $_GET['upd'] : "";
$del = isset($_GET['del']) ? $_GET['del'] : "";

$lst = isset($_GET['lst']) ? $_GET['lst'] : "";
$val = isset($_GET['val']) ? $_GET['val'] : "";

$link	= @DbConnect($dbhost,$dbuser,$dbpass,$dbname);
if($chg){
	$query	= GenQuery('stock','s','*','','',array('serial'),array('='),array($chg) );
	$res	= @DbQuery($query,$link);
	$nitm	= @DbNumRows($res);
	if ($nitm != 1) {
		echo "<h4>$chg: $nitm $vallbl!</h4>";
		@DbFreeResult($res);
	}else{
		$item = @DbFetchRow($res);
	}
	@DbFreeResult($res);
	$ser   = $item[0];
	$typ   = $item[1];
	$loc   = $item[4];
	$sta   = $item[5];
	$com   = $item[6];
	$wty   = date("m/d/Y",$item[7]);
	$src   = $item[8];
	$oper  = "upd";
	$oplbl = "$updlbl";
}else{
	$ser = isset($_GET['ser']) ? $_GET['ser'] : "";
	$typ = isset($_GET['typ']) ? $_GET['typ'] : "";
	$loc = isset($_GET['loc']) ? $_GET['loc'] : "-";
	$sta = isset($_GET['sta']) ? $_GET['sta'] : 10;
	$com = isset($_GET['com']) ? $_GET['com'] : "";
	$wty = isset($_GET['wty']) ? $_GET['wty'] : date("m/d/Y",time()+86400*365*3);
	$src = isset($_GET['src']) ? $_GET['src'] : "-";
	$oper  = "add";
	$oplbl = "$addbtn";
}
$now  = time();
$wint = strtotime( preg_replace("/\s.*$/", "", $wty) );					# Forget the hour on Warranty

?>
<h1>Stock <?=$mgtlbl?></h1>
<form method="get" action="<?=$self?>.php" name="add">
<table class="content"><tr class="<?=$modgroup[$self]?>1">
<th width=80><a href="<?=$self?>.php"><img src="img/32/<?=$selfi?>.png"></a></th>

<th align="right">
<?=$serlbl?> <input type="text" name="ser" value="<?=$ser?>" size="20" OnFocus="select();" <?=(($chg)?"readonly":"")?>><br>
<?=$typlbl?> <input type="text" name="typ" value="<?=$typ?>" size="20" OnFocus="select();"><br>
<?=$loclbl?> <input type="text" name="loc" value="<?=$loc?>" size="20" OnFocus="select();"><br>
<?=$srclbl?> <input type="text" name="src" value="<?=$src?>" size="20" OnFocus="select();"><br>
<?=$wtylbl?> <a href="javascript:show_calendar('add.wty');"><img src="img/16/date.png"></a>
<input type="text" name="wty" value="<?=$wty?>" size="16" OnFocus="select();">
</th>
<th valign="top">
<?=$cmtlbl?><br>
<textarea rows="5" name="com" cols="30"><?=$com?></textarea>

</th>
<th valign="top">
<?=$stalbl?><br>
<select size="4" name="sta">
<?
foreach (array_keys($stco) as $c){
	echo "<option value=\"$c\" ".( ($c == $sta)?"selected":"").">$stco[$c]\n";
}
?>
</select>
</th>
<th width="80">
<input type="submit" value="<?=$oplbl?>" name="<?=$oper?>">
</th></tr>
</table></form>
<script type="text/javascript">
document.add.ser.focus();
</script>
<p>
<?

if($lst){
	if($lst == "ty"){
		echo "<h2>$typlbl \"$val\" $lstlbl</h2>\n";
		$col = "type";
	}elseif($lst == "lo"){
		echo "<h2>$loclbl \"$val\" $lstlbl</h2>\n";
		$col = "location";
	}elseif($lst == "st"){
		echo "<h2>$stalbl \"$stco[$val]\" $lstlbl</h2>\n";
		$col = "state";
	}elseif($lst == "us"){
		echo "<h2>$usrlbl \"$val\" $lstlbl</h2>\n";
		$col = "user";
	}elseif($lst == "sc"){
		echo "<h2>$srclbl \"$val\" $lstlbl</h2>\n";
		$col = "source";
	}else{
		echo "<h2>$wtylbl \"".date($datfmt,$val)."\" $lstlbl</h2>\n";
		$col = "lastseen";
	}
?>
	<table class="content">
	<tr class="<?=$modgroup[$self]?>2">
	<th colspan="2"><img src="img/32/key.png"><br><?=$serlbl?></th>
	<th><img src="img/32/abc.png"><br><?=$typlbl?></th>
	<th><img src="img/32/user.png"><br><?=$usrlbl?></th>
	<th><img src="img/32/clock.png"><br><?=$updlbl?></th>
	<th><img src="img/32/home.png"><br><?=$loclbl?></th>
	<th><img src="img/32/find.png"><br><?=$deslbl?></th>
	<th><img src="img/32/ugrp.png"><br><?=$srclbl?></th>
	<th><img src="img/32/flag.png"><br><?=$wtylbl?></th>
	<th><img src="img/32/cog.png"><br><?=$cmdlbl?></th></tr>	
<?
	$query	= GenQuery('stock','s','*','type,serial','',array("$col"),array('='),array("$val") );
	$res	= @DbQuery($query,$link);
	if($res){
		$row = 0;
		while( ($item = @DbFetchRow($res)) ){
			if ($row % 2){$bg = "txta"; $bi = "imga";}else{$bg = "txtb"; $bi = "imgb";}
			$row++;
			$us  = rawurlencode($item[0]);
			list($a1c,$a2c) = Agecol($item[3],$item[3],$row % 2);
			echo "<tr class=\"$bg\"><th class=\"$bi\">\n";
			echo "<img src=\"img/16/" . $cico[$item[5]] . ".png\" title=" . $stco[$item[5]] . "></th><td>$item[0]</td>\n";
			echo "<td><a href=\"?lst=ty&val=".rawurlencode($item[1])."\">$item[1]</a></td>\n";
			echo "<td><a href=\"?lst=us&val=".rawurlencode($item[2])."\">$item[2]</a></td><td bgcolor=#$a1c>".date($datfmt,$item[3])."</td>\n";
			echo "<td><a href=\"?lst=lo&val=".rawurlencode($item[4])."\">$item[4]</a></td><td>$item[6]</td>";
			echo "<td><a href=\"?lst=sc&val=".rawurlencode($item[8])."\">$item[8]</a></td><td>".date($datfmt,$item[7])."</td><td align=center>\n";
			echo "<a href=?chg=$us><img src=\"img/16/note.png\" title=\"$chglbl\"></a>\n";
			echo "<a href=?del=$us><img src=\"img/16/bcnl.png\" onclick=\"return confirm('$delbtn $item[0]?')\" title=\"Delete!\"></a>\n";
			echo "</td></tr>\n";
		}
		@DbFreeResult($res);
	}else{
		print @DbError($link);
	}
?>
	</table>
	<table class="content">
	<tr class="<?=$modgroup[$self]?>2"><td><?=$row?> <?=$vallbl?> (<?=$query?>)</td></tr>
	</table>
<?
	include_once ("inc/footer.php");
	exit;
}

if ($add and $ser and $typ){
	$query	= GenQuery('stock','i','','','',array('serial','type','user','time','location','state','comment','lastseen','source'),'',array($ser,$typ,$_SESSION['user'],$now,$loc,$sta,$com,$wint,$src) );
	if( !@DbQuery($query,$link) ){echo "<h4>".DbError($link)."</h4>";}else{echo "<h5>$serlbl $_GET[ser] $updlbl OK</h5>";}
}elseif ($upd and $ser and $typ){
	$query	= GenQuery('stock','u','serial',$ser,'',array('type','user','time','location','state','comment','lastseen','source'),array(''),array($typ,$_SESSION['user'],$now,$loc,$sta,$com,$wint,$src ) );
	if( !@DbQuery($query,$link) ){echo "<h4>".DbError($link)."</h4>";}else{echo "<h5>$serlbl $_GET[ser] $updlbl OK</h5>";}
}elseif($del ){
#}elseif($del and preg_match("/adm/",$_SESSION['group'])){
	$query	= GenQuery('stock','d','','','',array('serial'),array('='),array($_GET['del']) );
	if( !@DbQuery($query,$link) ){echo "<h4>".DbError($link)."</h4>";}else{echo "<h5>$serlbl $del $delbtn OK</h5>";}
}
?>

<table class="full fixed"><tr><td class="helper">

<h2><?=$typlbl?> <?=$sumlbl?></h2>
<table class="content">
<tr class="<?=$modgroup[$self]?>2">
<th><img src="img/32/abc.png"><br><?=$typlbl?></th>
<th><img src="img/32/form.png"><br><?=$numlbl?></th>

<?
$query	= GenQuery('stock','g','type');
$res	= @DbQuery($query,$link);
if($res){
	$row = 0;
	while( ($item = @DbFetchRow($res)) ){
		if ($row % 2){$bg = "txta"; $bi = "imga";}else{$bg = "txtb"; $bi = "imgb";}
		$row++;
		$stbar = Bar($item[1],0);
		echo "<tr class=\"$bg\">\n";
		echo "<td><a href=\"?lst=ty&val=".rawurlencode($item[0])."\">$item[0]</a></td><td>$stbar $item[1]</td></tr>\n";
	}
}
?>
</table>
<table class="content">
<tr class="<?=$modgroup[$self]?>2"><td><?=$row?> <?=$vallbl?> (<?=$query?>)</td></tr>
</table>

</td><td class="helper">

<h2><?=$wtylbl?> <?=$sumlbl?></h2>
<table class="content">
<tr class="<?=$modgroup[$self]?>2">
<th colspan="2"><img src="img/32/date.png"><br><?=$wtylbl?></th>
<th><img src="img/32/form.png"><br><?=$numlbl?></th>

<?
$query	= GenQuery('stock','g','lastseen','lastseen',10);
$res	= @DbQuery($query,$link);
if($res){
	$row = 0;
	while( ($item = @DbFetchRow($res)) ){
		if ($row % 2){$bg = "txta"; $bi = "imga";}else{$bg = "txtb"; $bi = "imgb";}
		$row++;
		$stbar = Bar($item[1],0);
		echo "<tr class=\"$bg\">\n";
		echo "<th>$row</th>\n";
		echo "<td><a href=\"?lst=wy&val=$item[0]\">". date($datfmt,$item[0]);
		if($now > $item[0]){echo "<img align=\"right\" src=\"img/16/flag.png\">";}
		echo "</a></td><td>$stbar $item[1]</td></tr>\n";
	}
}
?>
</table>
<table class="content">
<tr class="<?=$modgroup[$self]?>2"><td><?=$row?> <?=$vallbl?> (<?=$query?>)</td></tr>
</table>

<h2><?=$srclbl?> <?=$sumlbl?></h2>
<table class="content">
<tr class="<?=$modgroup[$self]?>2">
<th><img src="img/32/ugrp.png"><br><?=$srclbl?></th>
<th><img src="img/32/form.png"><br><?=$numlbl?></th>

<?
$query	= GenQuery('stock','g','source');
$res	= @DbQuery($query,$link);
if($res){
	$row = 0;
	while( ($item = @DbFetchRow($res)) ){
		if ($row % 2){$bg = "txta"; $bi = "imga";}else{$bg = "txtb"; $bi = "imgb";}
		$row++;
		$stbar = Bar($item[1],0);
		echo "<tr class=\"$bg\">\n";
		echo "<td><a href=\"?lst=sc&val=".rawurlencode($item[0])."\">$item[0]</a></td><td>$stbar $item[1]</td></tr>\n";
	}
}
?>
</table>
<table class="content">
<tr class="<?=$modgroup[$self]?>2"><td><?=$row?> <?=$vallbl?> (<?=$query?>)</td></tr>
</table>

<h2><?=$loclbl?> <?=$sumlbl?></h2>
<table class="content">
<tr class="<?=$modgroup[$self]?>2">
<th><img src="img/32/home.png"><br><?=$loclbl?></th>
<th><img src="img/32/form.png"><br><?=$numlbl?></th>

<?
$query	= GenQuery('stock','g','location');
$res	= @DbQuery($query,$link);
if($res){
	$row = 0;
	while( ($item = @DbFetchRow($res)) ){
		if ($row % 2){$bg = "txta"; $bi = "imga";}else{$bg = "txtb"; $bi = "imgb";}
		$row++;
		$stbar = Bar($item[1],0);
		echo "<tr class=\"$bg\">\n";
		echo "<td><a href=\"?lst=lo&val=".rawurlencode($item[0])."\">$item[0]</a></td><td>$stbar $item[1]</td></tr>\n";
	}
}
?>
</table>
<table class="content">
<tr class="<?=$modgroup[$self]?>2"><td><?=$row?> <?=$vallbl?> (<?=$query?>)</td></tr>
</table>

<h2><?=$usrlbl?> <?=$sumlbl?></h2>
<table class="content">
<tr class="<?=$modgroup[$self]?>2">
<th><img src="img/32/user.png"><br><?=$usrlbl?></th>
<th><img src="img/32/form.png"><br><?=$numlbl?></th>
<?
$query	= GenQuery('stock','g','user');
$res	= @DbQuery($query,$link);
if($res){
	$row = 0;
	while( ($item = @DbFetchRow($res)) ){
		if ($row % 2){$bg = "txta"; $bi = "imga";}else{$bg = "txtb"; $bi = "imgb";}
		$row++;
		$stbar = Bar($item[1],0);
		echo "<tr class=\"$bg\">\n";
		echo "<td><a href=\"?lst=us&val=".rawurlencode($item[0])."\">$item[0]</a></td><td>$stbar $item[1]</td></tr>\n";
	}
}
?>
</table>
<table class="content">
<tr class="<?=$modgroup[$self]?>2"><td><?=$row?> <?=$vallbl?> (<?=$query?>)</td></tr>
</table>

<h2><?=$stalbl?> <?=$sumlbl?></h2>
<table class="content">
<tr class="<?=$modgroup[$self]?>2">
<th colspan="2"><img src="img/32/find.png"><br><?=$stalbl?></th>
<th><img src="img/32/form.png"><br><?=$numlbl?></th>
<?
$query	= GenQuery('stock','g','state');
$res	= @DbQuery($query,$link);
if($res){
	$row = 0;
	while( ($item = @DbFetchRow($res)) ){
		if ($row % 2){$bg = "txta"; $bi = "imga";}else{$bg = "txtb"; $bi = "imgb";}
		$row++;
		$stbar = Bar($item[1],0);
		echo "<tr class=\"$bg\">\n";
		echo "<th class=\"$bi\"><img src=\"img/16/" . $cico[$item[0]] . ".png\" title=" . $stco[$item[0]] . "></th>\n";
		echo "<td><a href=\"?lst=st&val=$item[0]\">". $stco[$item[0]] ."</a></td><td>$stbar $item[1]</td></tr>\n";
	}
}
?>
</table>
<table class="content">
<tr class="<?=$modgroup[$self]?>2"><td><?=$row?> <?=$vallbl?> (<?=$query?>)</td></tr>
</table>

</td></tr></table>

<?
include_once ("inc/footer.php");
?>
