<?
/*
#============================================================================
# Program: Monitoring-Messages.php
# Programmer: Remo Rickli
#
# DATE		COMMENT
# -----------------------------------------------------------
# 07/06/05	initial version.
# 17/03/06	new SQL query support
# 11/07/06	added paging
# 30/03/07	improved paging, added shortcuts
# 04/09/07	implemented CSS scheme
# 20/09/07	implemented language support
*/

// Seconds between reloading
$timer = 60;

$calendar= 1;

include_once ("inc/header.php");
include_once ("inc/libmon.php");

$_GET = sanitize($_GET);
$sta = isset($_GET['sta']) ? $_GET['sta'] : "";
$stb = isset($_GET['stb']) ? $_GET['stb'] : "";
$ina = isset($_GET['ina']) ? $_GET['ina'] : "";
$inb = isset($_GET['inb']) ? $_GET['inb'] : "";
$opa = isset($_GET['opa']) ? $_GET['opa'] : "";
$opb = isset($_GET['opb']) ? $_GET['opb'] : "";
$cop = isset($_GET['cop']) ? $_GET['cop'] : "";
$lvl = isset($_GET['lvl']) ? $_GET['lvl'] : "";
$lim = isset($_GET['lim']) ? $_GET['lim'] : 10;
$off = (isset($_GET['off']) and !isset($_GET['sho']))? $_GET['off'] : 0;

if($lvl){
	$in[] = 'level';
	$op[] = '=';
	$st[] = $lvl;
	if($sta or $cop){$co[] = 'AND';}
}
$in[] = $ina;
$in[] = $inb;
$op[] = $opa;
$op[] = $opb;
$st[] = $sta;
$st[] = $stb;
$co[] = $cop;

$nof = $off;
if( isset($_GET['p']) ){
	$nof = abs($off - $lim);
}elseif( isset($_GET['n']) ){
	$nof = $off + $lim;
}
$dlim = ($lim)?"$nof,$lim":0;

$link	= @DbConnect($dbhost,$dbuser,$dbpass,$dbname);
if( isset($_GET['del']) ){
	if(preg_match("/adm/",$_SESSION['group']) ){
		$query	= GenQuery('messages','d','*','id desc',$lim,$in,$op,$st,$co );
		if(@DbQuery($query,$link) ){
			echo "<h5> $msglbl $delbtn OK </h5>";
		}else{
			echo "<h4>".DbError($link)."</h4>";
		}
	}else{
		echo $nokmsg;
	}
}

$cols = array(	"id"=>"ID",
		"level"=>"$levlbl",
		"time"=>$timlbl,
		"source"=>$srclbl,
		"info"=>"Info"
		);

?>
<h1>Monitoring <?=$msglbl?></h1>
<form method="get" name="list" action="<?=$self?>.php">
<table class="content"><tr class="<?=$modgroup[$self]?>1">
<th width="80"><a href="<?=$self?>.php"><img src="img/32/<?=$selfi?>.png"></a></th>
<th valign="top"><?=$cndlbl?> A<p>
<SELECT size="1" name="ina">
<?
foreach ($cols as $k => $v){
       echo "<option value=\"$k\"".( ($ina == $k)?"selected":"").">$v\n";
}
?>
</SELECT>
<SELECT size="1" name="opa">
<? selectbox("oper",$opa);?>
</SELECT>
<p><a href="javascript:show_calendar('list.sta');"><img src="img/16/date.png"></a>
<input type="text" name="sta" value="<?=$sta?>" size="20">
</th>
<th valign="top"><?=$cmblbl?><p>
<SELECT size="1" name="cop">
<? selectbox("comop",$cop);?>
</SELECT>
</th>
<th valign="top"><?=$cndlbl?> B<p>
<SELECT size="1" name="inb">
<?
foreach ($cols as $k => $v){
       echo "<option value=\"$k\"".( ($inb == $k)?"selected":"").">$v\n";
}
?>
</SELECT>
<SELECT size="1" name="opb">
<? selectbox("oper",$opb);?>
</SELECT>
<p><a href="javascript:show_calendar('list.stb');"><img src="img/16/date.png"></a>
<input type="text" name="stb" value="<?=$stb?>" size="20">
</th>
<th valign="top"><?=$levlbl?><p>
<SELECT size="1" name="lvl">
<OPTION VALUE=""><?=$sellbl?> ->
<?
foreach (array_keys($mlvl) as $ml){
	echo "<option value=\"$ml\" ";
	if($ml == $lvl){echo "selected";}
	echo ">$mlvl[$ml]\n";
}
?>
</SELECT>
<p>
<a href="?ina=info&opa=regexp&sta=traffic%7Cerrors"><img src="img/16/radr.png" title=" <?=$trflbl?>"></a>
<a href="?ina=info&opa=regexp&sta=config"><img src="img/16/conf.png" title="Configuration"></a>
<a href="?ina=info&opa=regexp&sta=CDP%7CLLDP%7Cdiscover%7Cdetected"><img src="img/16/find.png" title="Discoveries"></a>
<br>
<a href="?ina=info&opa=regexp&sta=login%7Cuser"><img src="img/16/user.png" title="Login <?=$msglbl?>"></a>
<a href="?ina=info&opa=regexp&sta=reboot%7Ccoldstart"><img src="img/16/exit.png" title="Reboots"></a>
<a href="?ina=info&opa=regexp&sta=%28reappeared%7CARP entries%29"><img src="img/16/node.png" title="Nodes <?=$msglbl?>"></a>
</th>
<th valign="top"><?=$limlbl?><p>
<SELECT size="1" name="lim">
<? selectbox("limit",$lim);?>
</SELECT>

<body onload='countdown()'>
<script language="javascript">
var interval = "";
var i = <?=$timer-1?>;

function countdown(){
	interval = window.setInterval("tick()",1000);
}

function tick(){
	var theElement = document.getElementById("ctr");
	theElement.innerHTML = i--;
	if (i < 9){
		document.getElementById("ctr").setAttribute("class", "drd");
	}
	if (i == -1) {
		document.list.submit();
	}
}
</script>
<p><br><span class="grn" id="ctr" width="20"><?=$timer?></span>
</th>

<th width="80">
<input type="submit" name="sho" value="<?=$shobtn?>">
<p>
<input type="hidden" name="off" value="<?=$nof?>">
<input type="submit" name="p" value="<">
<input type="submit" name="n" value=">">
<p>

<input type="submit" name="del" value="<?=$delbtn?>" onclick="return confirm('<?=$delbtn?> <?=$msglbl?>?')" >
</th></tr>
</table></form>
<p>
<?
Messages(GenQuery('messages','s','*','id desc',$dlim,$in,$op,$st,$co ),2);

include_once ("inc/footer.php");
?>
