<?
/*
#============================================================================
# Program: System-Files.php
# Programmer: Remo Rickli
#
# DATE		COMMENT
# -----------------------------------------------------------
# 10/25/09	initial version, based on B. Eschlwech's contribution
*/

include_once ("inc/header.php");

$mysrv['Moni']['cmd'] = "$nedipath/moni.pl -D";
$mysrv['Moni']['ico'] = "bino";

$mysrv['Syslog']['cmd'] = "$nedipath/syslog.pl -Dp 1514";
$mysrv['Syslog']['ico'] = "bell";

$mysrv['Trapd']['cmd'] = "snmptrapd -c /etc/snmp/snmptrapd.conf 1162";
$mysrv['Trapd']['ico'] = "flag";

$pscmd = "ps -axo pid,command";

$_GET = sanitize($_GET);
$stop = (isset($_GET['stop']) and in_array($_GET['stop'],array_keys($mysrv) ) ) ? $_GET['stop'] : "";
$start = (isset($_GET['start']) and in_array($_GET['start'],array_keys($mysrv) ) ) ? $_GET['start'] : "";
$clear = (isset($_GET['clear']))? $_GET['clear'] : "";

function GetPID ($srv){

	global $procs;

	$pids = explode ("\n", $procs);
	foreach ($pids as $pid){
		if (strstr ($pid, $srv)){
			return strtok ($pid, " ");
		}
	}
	return 0;
}

$procs = shell_exec($pscmd);							# Get PIDs first
$link	= @DbConnect($dbhost,$dbuser,$dbpass,$dbname);

if($start){
	if( $pid = GetPID($mysrv[$start]['cmd']) ){
		echo "<h4>$start Running with PID $pid!</h4>";
	}else{
		system($mysrv[$start]['cmd']." > /dev/null");
		$procs = shell_exec($pscmd);					# Refresh PIDs after start
	}
}elseif($stop){
	if( $pid = GetPID($mysrv[$stop]['cmd']) ){
		posix_kill ($pid, 9);
		$procs = shell_exec($pscmd);					# Refresh PIDs after kill
	}else{
		echo "<h4>$stop not Running!</h4>";
	}
}elseif($clear){
	$query	= GenQuery('system','u','name','threads','',array('value'),'',array('0') );
	if( !@DbQuery($query,$link) ){echo "<h4>".DbError($link)."</h4>";}else{echo "<h5>threads $resbtn OK</h5>";}
	$query	= GenQuery('system','u','name','nodlock','',array('value'),'',array('0') );
	if( !@DbQuery($query,$link) ){echo "<h4>".DbError($link)."</h4>";}else{echo "<h5>nodlock $resbtn OK</h5>";}

	if( $pid = GetPID('nedi.pl') ){
		posix_kill ($pid, 9);
		$procs = shell_exec($pscmd);					# Refresh PIDs after kill
	}else{
		echo "<h4>nedi.pl not Running!</h4>";
	}
}

$query	= GenQuery('system','s');
$res	= @DbQuery($query,$link);
while( $s = @DbFetchRow($res) ){
	$sys[$s[0]] = $s[1];
}
@DbFreeResult($res);

ob_end_flush();
?>
<h1>NeDi Services</h1>
<p>
<form name="form" action="<?=$self?>.php" method="post">
<table class="content">
<tr class="<?=$modgroup[$self]?>1">
<th width="80" class="<?=$modgroup[$self]?>1"><a href="<?=$self?>.php"><img src="img/32/<?=$selfi?>.png"></a></th>
<td><table width="100%">
<th><h3>Service</h3></th><th><h3>Status / Action</h3></th>
</tr>
<?

foreach (array_keys($mysrv) as $p ){
?>
<tr class="<?=$modgroup[$self]?>2">
<th><img src="img/32/<?=$mysrv[$p]['ico']?>.png"> <?=$p?></th>
<th><a href="<?=( GetPID($mysrv[$p]['cmd']) )?"?stop=$p\"><img src=\"img/32/bchk.png\" title=\"$resbtn\">":"?start=$p\"><img src=\"img/32/bcls.png\" title=\"$cmdlbl\">"?></a></th>
</tr>
<?
}
?>
<tr class="<?=$modgroup[$self]?>2">
<th><img src="img/32/find.png"> NeDi</th>
<th>
<?=$sys['threads']?> Threads 
 <img src="img/16/<?=($sys['nodlock'])?"lokc.png\" title=\"Nodes Locked\">":"loko.png\" title=\"Nodes Unlocked\">"?>
<a href="?clear=1"><img src="img/16/bcnl.png" align="right" onclick="return confirm('<?=$resbtn?> Discovery???')" title="<?=$resbtn?> Discovery"></a>
</th>
</tr>
</table></td></tr></table>
<h2>Processes</h2>
<div class="textpad code txta">
<?=$procs?>
</div>
<?
if( file_exists("/usr/bin/top") ){
?>
<h2>Utilization</h2>
<div class="textpad code txta">
<?=shell_exec("/usr/bin/top -d1")?>
</div>

<?
}

if( file_exists("/usr/bin/systat") ){
?>
<h2>Sensors</h2>
<div class="textpad code txta">
<?=shell_exec("/usr/bin/systat -b sensors")?>
</div>

<?
}
include_once ("inc/footer.php");
?>
