<?
/*
#============================================================================
# Program: Monitoring-Health.php
# Programmer: Remo Rickli
#
# DATE		COMMENT
# -----------------------------------------------------------
# 08/06/05	initial version.
# 10/03/06	new SQL query support
# 17/04/07	extended monitoring
# 12/07/07	new location and function scheme
# 04/09/07	implemented CSS scheme
# 20/09/07	implemented language support
# 22/01/08	Uptime Monitoring Status
*/

error_reporting(E_ALL ^ E_NOTICE);

// Seconds between reloading
$refresh= 60;

include_once ("inc/header.php");
include_once ("inc/libdev.php");
include_once ("inc/libmon.php");

$_GET = sanitize($_GET);
$reg = isset($_GET['reg']) ? $_GET['reg'] : "";
$cty = isset($_GET['cty']) ? $_GET['cty'] : "";
$bld = isset($_GET['bld']) ? $_GET['bld'] : "";

$link	= @DbConnect($dbhost,$dbuser,$dbpass,$dbname);
$query	= GenQuery('monitoring');
$res	= @DbQuery($query,$link);
if($res){
	$nmon= 0;
	$mal = 0;
	$lck = 0;
	while( ($m = @DbFetchRow($res)) ){
		$deval[$m[0]] = $m[1];
		if($m[9] > $delay){$devdy[$m[0]] = $m[9];}
		if($m[1]){$mal++;}
		if($m[5] > $lck){$lck = $m[5];}
		$nmon++;
	}
	@DbFreeResult($res);
}else{
	print @DbError($link);
}
?>
<h1>Monitoring Health</h1>
<table class="content"><tr class="<?=$modgroup[$self]?>1">
<th width="80"><a href="<?=$self?>.php"><img src="img/32/<?=$selfi?>.png"></a></th>
<td valign="top" align="center"><h3>Monitoring</h3><p>
<?
if($_SESSION['gsiz']){
?>
<a href="Reports-Monitoring.php?rep[]=dav"><img src="inc/drawrrd.php?t=mon&s=<?=$_SESSION[gsiz]?>" title="Device <?=$avalbl?>"></a>
<a href="Monitoring-Timeline.php?det=on"><img src="inc/drawrrd.php?t=msg&s=<?=$_SESSION[gsiz]?>" title="<?=$msglbl?>"></a>
<?
}else{
?>
<img src="img/32/dev.png"" title="Monitoring <?=$nmon?> devices">
<?
}
if($mal == 0){
	if( time() > (1.5 * $pause + $lck) ){
		if(!$_SESSION['gsiz']){echo "<img src=\"img/32/bcnl.png\" title=\"moni.pl? $laslbl ".date($datfmt,$lck)."\">";}
		if($_SESSION['vol']){echo "<embed src=\"inc/enter2.mp3\" volume=\"$_SESSION[vol]\" hidden=\"true\">\n";}
	}else{
		if(!$_SESSION['gsiz']){echo "<img src=\"img/32/bchk.png\" title=\"OK $laslbl ".date($datfmt,$lck)."\">";}
	}

	if(!$_SESSION['gsiz']){
		$query	= GenQuery('links','m','*','','power',array("power"),array('>'),array('0') );
		$res	= @DbQuery($query,$link);
		if($res){
			$m = @DbFetchRow($res);
			echo "<h3><br><img src=\"img/32/batt.png\" title=\"PoE on $m[0] links\">";
			echo ($m[1]/1000)." W</h3>";
			@DbFreeResult($res);
		}else{
			print @DbError($link);
		}
	}
}else{
	if($mal == 1){
		if(!$_SESSION['gsiz']){echo "<img src=\"img/32/bell.png\" title=\"1 active incident\">";}
		if($_SESSION['vol']){echo "<embed src=\"inc/alarm1.mp3\" volume=\"$_SESSION[vol]\" hidden=\"true\">\n";}
	}elseif($mal < 10){
		if(!$_SESSION['gsiz']){echo "<img src=\"img/32/warn.png\" title=\"$mal active incidents\">";}
		if($_SESSION['vol']){echo "<embed src=\"inc/alarm2.mp3\" volume=\"$_SESSION[vol]\" hidden=\"true\">\n";}
	}else{
		if(!$_SESSION['gsiz']){echo "<img src=\"img/32/flag.png\" title=\"$mal active incidents!\">";}
		if($_SESSION['vol']){echo "<embed src=\"inc/alarm3.mp3\" volume=\"$_SESSION[vol]\" hidden=\"true\">\n";}
	}
	
?>
<p>
<table class="content"><tr class="<?=$modgroup[$self]?>2">
<th><img src="img/16/dev.png"><br>Device</th><th><img src="img/16/flag.png"><br><?=$mlvl['200']?></th>
<?
	$row = 0;
	foreach(array_keys($deval) as $d){
		if($deval[$d]){
			if ($row % 2){$bg = "txta"; $bi = "imga";}else{$bg = "txtb"; $bi = "imgb";}
			$row++;
			list($statbg,$stat) = StatusBg(1,1,$deval[$d],$bi);
			$ud	= rawurlencode($d);
			echo "<tr class=\"$bg\"><th>\n";
			echo "<a href=Devices-Status.php?dev=$ud&shg=on&shp=on>$d</a></th><td class=\"$statbg\">$stat</td></tr>\n";
		}
	}
?>
</table>
<?
}
if( count($devdy) ){
?>
<p>
<table class="content"><tr class="<?=$modgroup[$self]?>2">
<th><img src="img/16/dev.png"><br>Device</th><th><img src="img/16/clock.png"><br>Delay</th>
<?
	$row = 0;
	foreach(array_keys($devdy) as $d){
		if ($row % 2){$bg = "txta"; $bi = "imga";}else{$bg = "txtb"; $bi = "imgb";}
		$row++;
		$ud	= rawurlencode($d);
		$dbar = Bar($devdy[$d],$delay,1);
		echo "<tr class=\"$bg\"><th>\n";
		echo "<a href=Devices-Status.php?dev=$ud&shg=on&shp=on>$d</a></th><td>$dbar $devdy[$d]ms</td></tr>\n";
	}
?>
</table>
<?
}
?>
</td>

<td valign="top" align="center">
<h3> <?=$inblbl?> <?=$oublbl?></h3><p>
<?
if($_SESSION['gsiz']){
?>
<a href="Reports-Devices.php?rep%5B%5D=poe"><img src="inc/drawrrd.php?t=tpw&s=<?=$_SESSION[gsiz]?>" title="PoE [W]"></a>
<a href="Reports-Interfaces.php?rep%5B%5D=itr"><img src="inc/drawrrd.php?t=ttr&s=<?=$_SESSION[gsiz]?>" title="<?=$trflbl?> [Mb/s]"></a>
<?
}

StatusIf('bbup',$inblbl);
StatusIf('bbdn',$oublbl);
?>
</td>

<td valign="top" align="center">
<h3><?=$errlbl?></h3><p>
<?
if($_SESSION['gsiz']){
?>
<a href="Reports-Interfaces.php?rep%5B%5D=itr#errors"><img src="inc/drawrrd.php?t=ter&s=<?=$_SESSION[gsiz]?>" title="<?=$errlbl?>/s"></a>
<a href="Reports-Interfaces.php?rep%5B%5D=dif"><img src="inc/drawrrd.php?t=tdi&s=<?=$_SESSION[gsiz]?>" title="Disabled Interfaces"></a>
<?
}
StatusIf('brup',$inblbl);
StatusIf('brdn',$oublbl);
StatusIf('bdis',"Disabled $tim[n]");
?>
</td>

<td valign="top" align="center" width="20%">
<h3><?=$stalbl?></h3><p>

<?
StatusSys('cpu','CPU');
StatusSys('mem','Mem');
StatusSys('home','Temp');
?>

</td></tr></table><p>
<?
if($_SESSION['lim']){
?>

<table class="full"><tr><td  width="20%" class="helper">

<h2> <?=$msglbl?> <?=$stslbl?></h2>
<?
	$query	= GenQuery('messages','g','level');
	$res	= @DbQuery($query,$link);
	if($res){
		$nlev = @DbNumRows($res);
		if($nlev){
			while( ($m = @DbFetchRow($res)) ){			# I do this in PHP, cauz SQL's order desc is slow with lots of messages...
				$msg[$m[0]] = $m[1];				# ...and I couldn't find a way to optimize it :-(
			}
?>
<table class="content"><tr class="<?=$modgroup[$self]?>2">
<th width="40"><img src="img/16/idea.png"><br><?=$levlbl?></th>
<th><img src="img/16/bell.png"><br><?=$msglbl?></th>
<?
			$row = 0;
			krsort($msg);
			foreach(array_keys($msg) as $l){
				if ($row % 2){$bg = "txta"; $bi = "imga";}else{$bg = "txtb"; $bi = "imgb";}
				$row++;
				$mbar = Bar($msg[$l],0,1);
				echo "<tr class=\"$bg\"><th class=\"$bi\">\n";
				echo "<img src=\"img/16/$mico[$l].png\" title=\"$mlvl[$l]\"></th><td>$mbar <a href=Monitoring-Messages.php?lvl=$l>$msg[$l]</a></td></tr>\n";
			}
			echo "</table>\n";
		}else{
			echo "<p><h5>0 $msglbl</h5>";	
		}
		@DbFreeResult($res);
	}else{
		print @DbError($link);
	}
?>

</td><td width=80% class="helper">

<h2><?=$mlvl[$msglevel]?> <?=$laslbl?></h2>
<?
	Messages(GenQuery('messages','s','*','id desc',$_SESSION['lim'],array('level'),array('>='),array("$msglevel") ) );
	echo "</td></tr></table>";
}

if($_SESSION['col']){
	TopoTable($reg,$cty,$bld);
	if (!$cty){
		TopoCities($_SESSION['col']);
	}elseif (!$bld){
		TopoBuilds($reg,$cty,$_SESSION['col']);
	}else{
		TopoFloors($reg,$cty,$bld,$_SESSION['col']);
	}
}

include_once ("inc/footer.php");

?>
