<?
/*
#============================================================================
# Program: Nodes-Toolbox.php
# Programmer: Eli Gill (based off of NeDi framework by Remo Rickli)
#
# DATE     COMMENT
# -------- ------------------------------------------------------------------
#08/01/07	Basic functionality works.  Need to output the results to a seperate table, clean up existing tables.
#08/02/07	Output goes into new table, but need to find a way to cleanup output.
#18/09/07	Adjustments to fit themes (Remo Rickli)
# 20/09/07	implemented language support (Remo Rickli)
# 29/11/07	Added Windows support (Marco Rauchenstein & Remo Rickli)
# 11/03/08	Fixed shell execution vulnerability
*/

include_once ("inc/header.php");

$_GET		= str_replace(";","", sanitize($_GET) );
$dest		= isset($_GET['Dest']) ? $_GET['Dest'] : $_SERVER['REMOTE_ADDR'];
$ping_count	= isset($_GET['Count']) ? $_GET['Count'] : 3;
$ping_size	= isset($_GET['Size']) ? $_GET['Size'] : 32;
$do		= isset($_GET['Do']) ? $_GET['Do'] : "";

?>
<h1><?=$netlbl?> Tool Box</h1>

<form method="get" action="<?=$self?>.php" name="nettools">
<table class="content" ><tr class="<?=$modgroup[$self]?>1">
<th width="80"><a href="<?=$self?>.php"><img src="img/32/<?=$selfi?>.png"></a></th>
<th>
<a href="log/putty.exe"><img src="img/16/lokc.png" title="Download Putty"></a>
</th><th>
<?=$dstlbl?> <input type="text" name="Dest" value="<?=$dest?>" size="15" />
<?=$numlbl?> <input type="text" name="Count" value="<?=$ping_count?>" size="2" />
<?=$sizlbl?> <input type="text" name="Size" value="<?=$ping_size?>" size="4" />
<input type="submit" value="Ping" name="Do"/>
<input type="submit" value="Lookup" name="Do"/>
<input type="submit" value="Traceroute" name="Do"/>
<input type="submit" value="Ping Range" name="Do"/>
<input type="submit" value="Scan" name="Do"/>
</th>
</table>
</form>

<?php
$sysos = SystemOS();
flush();

if($do == "Ping"){
	echo "<h2>$ping_count Ping(s) with $ping_size bytes to $dest</h2><div class=\"textpad code txta\">";
	if($sysos == "win"){
		system("ping -n $ping_count -l $ping_size $dest");
	}else{
		system("ping -c $ping_count -s $ping_size $dest");
	}
}elseif($do == "Lookup"){
	echo "<h2>DNS Lookup for $dest</h2><div class=\"textpad code txtb\">";
	system("nslookup $dest");
}elseif($do == "Scan"){
	echo "<h2>Nmap Scan of $dest</h2><div class=\"textpad code txtb\">";
	system("nmap -sSU -F $dest");
}elseif($do == "Ping Range"){
	echo "<h2>Nmap Ping Range of $dest</h2><div class=\"textpad code txtb\">";
	system("nmap -sP $dest");
}elseif($do == "Traceroute"){
	echo "<h2>Traceroute to $dest</h2><div class=\"textpad code txtb\">";
	if($sysos == "win"){
		system("tracert $dest");
	}else{
		system("traceroute $dest");
	}
}
?>
</div>
<?
include_once ("inc/footer.php");
?>
