<?
/*
#============================================================================
# Program: Reports-Devices.php
# Programmer: Remo Rickli
#
# DATE		COMMENT
# -----------------------------------------------------------
# 21/04/05	initial version.
# 20/03/06	new SQL query support
# 04/09/07	implemented CSS scheme, added vtp mode report
# 20/09/07	implemented language support
*/

error_reporting(E_ALL ^ E_NOTICE);

include_once ("inc/header.php");
include_once ('inc/libdev.php');

$_GET = sanitize($_GET);
$rep = isset($_GET['rep']) ? $_GET['rep'] : array();
$lim = isset($_GET['lim']) ? $_GET['lim'] : 10;
$ord = isset($_GET['ord']) ? "checked" : "";
?>
<h1>Device Reports</h1>
<form method="get" action="<?=$self?>.php">
<table class="content"><tr class="<?=$modgroup[$self]?>1">
<th width=80><a href="<?=$self?>.php"><img src="img/32/<?=$selfi?>.png"></a></th>
<th><?=$sellbl?></th>
<th>
<select multiple name="rep[]" size="4">
<option value="typ" <? if(in_array("typ",$rep)){echo "selected";} ?> ><?=$typlbl?>
<option value="sft" <? if(in_array("sft",$rep)){echo "selected";} ?> >Software
<option value="vtp" <? if(in_array("vtp",$rep)){echo "selected";} ?> >VTP <?=$sumlbl?>
<option value="poe" <? if(in_array("poe",$rep)){echo "selected";} ?> >PoE <?=$sumlbl?>
<option value="ust" <? if(in_array("ust",$rep)){echo "selected";} ?> ><?=$updlbl?>
</select></th>
</th>
<th>
 <?=$limlbl?> 
<select size=1 name="lim">
<? selectbox("limit",$lim);?>
</select>
</th>
<th>
<input type="checkbox" name="ord" <?=$ord?> > <?=$altlbl?>
</th>
</select></th>

<th width=80><input type="submit" name="do" value="<?=$shobtn?>"></th>
</tr></table></form><p>
<?
if($rep){
$link	= @DbConnect($dbhost,$dbuser,$dbpass,$dbname);
$query	= GenQuery('devices');
$res	= @DbQuery($query,$link);
if($res){
	$ndev = 0;
	while( ($d = @DbFetchRow($res)) ){
		$dtyp[$d[3]]++;
		$dico[$d[3]] = $d[18];
		$dico[$d[0]] = $d[18];
		$devup[$d[4]]['fs']++;
		$devup[$d[5]]['ls']++;
		$dops[$d[8]]++;
		$dbim[$d[9]]++;
		$vtpd[$d[12]]++;
		$vtpm[$d[13]]++;
		$ndev++;
	}
	@DbFreeResult($res);
}else{
	print @DbError($link);
	die;
}

if ( in_array("typ",$rep) ){
?>
<h2>Device <?=$typlbl?></h2>
<table class="content"><tr class="<?=$modgroup[$self]?>2">
<th colspan=2 width=33%><img src="img/32/abc.png"><br><?=$typlbl?></th>
<th><img src="img/32/dev.png"><br>Devices</th><th width="20%"><img src="img/32/cog.png"><br><?=$cmdlbl?></th>
<?
	$ntyp = 0;
	if($ord){
		ksort($dtyp);
	}else{
		arsort($dtyp);
	}
	$row = 0;
	foreach ($dtyp as $typ => $n){
		if ($row % 2){$bg = "txta"; $bi = "imga";}else{$bg = "txtb"; $bi = "imgb";}
		$row++;
		$img	= $dico[$typ];
		$tbar	= Bar($n,0);
		$utyp	= rawurlencode($typ);
		echo "<tr class=\"$bg\"><th class=\"$bi\" width=10%>\n";
		echo "<img src=\"img/dev/$img.png\" title=\"$typ\"></th>\n";
		echo "<td>$typ</a></td><td>$tbar $n</td><th>\n";
		echo "<a href=Devices-List.php?ina=type&opa==&sta=$utyp><img src=\"img/16/dev.png\" title=\"Inventory\"></a>\n";
		echo "<a href=Reports-Modules.php?rep[]=inv&flt=$utyp><img src=\"img/16/pcm.png\" title=\"Device $lstlbl\"></a>\n";
		echo "<a href=\"Topology-Map.php?mod=f&ipi=on&ina=type&flt=$utyp&draw=png\"><img src=\"img/16/paint.png\" title=\"Topology Map\"></a>\n";
		echo "</th></tr>\n";
	}
	?>
</table>
<table class="content" >
<tr class="<?=$modgroup[$self]?>2"><td><?=$row?> <?=$typlbl?>, <?=$ndev?> devices total</td></tr>
</table>
	<?
}

if ( in_array("sft",$rep) ){
?>

<table class="full fixed"><tr><td class="helper">

<h2>Operating Systems</h2>
<table class="content"><tr class="<?=$modgroup[$self]?>2">
<th><img src="img/32/cog.png"><br>OS</th>
<th><img src="img/32/dev.png"><br>Devices</th>
<?
	if($ord){
		ksort($dops);
	}else{
		arsort($dops);
	}
	$row = 0;
	foreach ($dops as $ops => $n){
		if ($row % 2){$bg = "txta"; $bi = "imga";}else{$bg = "txtb"; $bi = "imgb";}
		$row++;
		if(!$ops){$ops="^$";}
		$tbar = Bar($n,0);
		$uops = rawurlencode($ops);
		echo "<tr class=\"$bg\">\n";
		echo "<td><a href=Devices-List.php?ina=os&opa==&sta=$uops>$ops</a></td>\n";
		echo "<td>$tbar $n</td></tr>\n";
	}
	?>
</table>
<table class="content" >
<tr class="<?=$modgroup[$self]?>2"><td><?=$row?> Operating Systems, <?=$ndev?> devices total</td></tr>
</table>

</td><td class="helper">

<h2>Boot Images</h2>
<table class="content"><tr class="<?=$modgroup[$self]?>2">
<th><img src="img/32/cbox.png"><br>Boot Image</th>
<th><img src="img/32/dev.png"><br>Devices</th>
<?
	if($ord){
		ksort($dbim);
	}else{
		arsort($dbim);
	}
	$row = 0;
	foreach ($dbim as $bim => $n){
		if ($row % 2){$bg = "txta"; $bi = "imga";}else{$bg = "txtb"; $bi = "imgb";}
		$row++;
		$o = "=";
		if(!$bim){$bim="^$";$o="regexp";}
		$tbar = Bar($n,0);
		$ubim = rawurlencode($bim);
		echo "<tr class=\"$bg\">\n";
		echo "<td><a href=Devices-List.php?ina=bootimage&opa=$o&sta=$ubim>$bim</a></td>\n";
		echo "<td>$tbar $n</td></tr>\n";
	}
	?>
</table>
<table class="content" >
<tr class="<?=$modgroup[$self]?>2"><td><?=$row?> Boot Images, <?=$ndev?> devices total</td></tr>
</table>

</td></tr></table>

	<?
}

if ( in_array("vtp",$rep) ){
?>

<table class="full fixed"><tr><td class="helper">

<h2>VTP Domains</h2>
<table class="content"><tr class="<?=$modgroup[$self]?>2">
<th width=33%><img src="img/32/vlan.png"><br>VTP Domain</th>
<th><img src="img/32/dev.png"><br>Devices</th>
<?
	if($ord){
		ksort($vtpd);
	}else{
		arsort($vtpd);
	}
	$row = 0;
	foreach ($vtpd as $vtp => $n){
		if ($row % 2){$bg = "txta"; $bi = "imga";}else{$bg = "txtb"; $bi = "imgb";}
		$row++;
		$op = "=";
		if(!$vtp){ $vtp = "^$"; $op = "regexp";}
		$tbar = Bar($n,0);
		$uvtp = rawurlencode($vtp);
		echo "<tr class=\"$bg\">\n";
		echo "<td><b> <a href=Topology-Map.php?prs=&x=1000&y=600&dep=24&tit=$uvtp+Domain&lev=3&mod=c&xo=0&yo=0&rot=0&lit=&lis=c&lwt=5&pos=&pwt=10&len=300&lsf=1.1&fpa=80&fco=6&bro=0&ifi=on&loi=on&ina=vtpdomain&flt=$uvtp&cs=&draw=png>$vtp</a></b></td><td>$tbar <a href=Devices-List.php?ina=vtpdomain&opa=$op&sta=$uvtp>$n</a></td></tr>\n";
	}
	?>
</table>
<table class="content" >
<tr class="<?=$modgroup[$self]?>2"><td><?=$row?> VTP domains, <?=$ndev?> devices total</td></tr>
</table>

</td><td class="helper">

<h2>VTP Modes</h2>
<table class="content"><tr class="<?=$modgroup[$self]?>2">
<th width=33%><img src="img/32/vlan.png"><br>VTP Mode</th>
<th><img src="img/32/dev.png"><br>Devices</th>
<?
	if($ord){
		ksort($vtpm);
	}else{
		arsort($vtpm);
	}
	$row = 0;
	foreach ($vtpm as $vtp => $n){
		if ($row % 2){$bg = "txta"; $bi = "imga";}else{$bg = "txtb"; $bi = "imgb";}
		$row++;
		$tbar = Bar($n,0);
		$uvtp = rawurlencode($vtp);
		echo "<tr class=\"$bg\">\n";
		echo "<th>".VTPmod($vtp)."</th><td>$tbar <a href=Devices-List.php?ina=vtpmode&opa==&sta=$vtp>$n</a></td></tr>\n";
	}
	?>
</table>
<table class="content" >
<tr class="<?=$modgroup[$self]?>2"><td><?=$row?> VTP domains, <?=$ndev?> devices total</td></tr>
</table>

</td></tr></table>

	<?
}

if ( in_array("poe",$rep) ){
?>
<table class="full fixed"><tr><td class="helper">

<h2>PoE Device <?=$sumlbl?></h2>
<table class="content"><tr class="<?=$modgroup[$self]?>2">
<th width=33%><img src="img/32/dev.png"><br>Device</th>
<th><img src="img/32/port.png"><br>PoE IF</th>
<th><img src="img/32/batt.png" title="Red threshold 1kW"><br>Total PoE</th>
<?
	if($ord){
		$query	= GenQuery('links','m','device','','power',array("power"),array('>'),array('0') );
	}else{
		$query	= GenQuery('links','m','device','sum desc','power',array("power"),array('>'),array('0') );
	}
	$res	= @DbQuery($query,$link);
	if($res){
		$row = 0;
		while( ($d = @DbFetchRow($res)) ){
			if ($row % 2){$bg = "txta"; $bi = "imga";}else{$bg = "txtb"; $bi = "imgb";}
			$row++;
			$pbar = Bar($d[2]/1000,1000);
			$ud = rawurlencode($d[0]);
			echo "<tr class=\"$bg\"><th class=\"$bi\">\n";
			echo "<a href=Devices-Status.php?dev=$ud><img src=\"img/dev/".$dico[$d[0]].".png\"></a><br><b>$d[0]</b></th>\n";
			echo "<th>$d[1]</th><td>$pbar ".($d[2]/1000)." W</td></tr>\n";
			if($row == $lim){break;}
		}
	}else{
		print @DbError($link);
	}
?>
</table>
<table class="content" >
<tr class="<?=$modgroup[$self]?>2"><td><?=$query?></td></tr>
</table>

</td><td class="helper">

<h2>Avg PoE / Interface</h2>
<table class="content"><tr class="<?=$modgroup[$self]?>2">
<th width=33%><img src="img/32/dev.png"><br>Devices</th>
<th><img src="img/32/port.png"><br>PoE IF</th>
<th><img src="img/32/batt.png"><br><?=$avglbl?> PoE Avg</th>
<?
	if($ord){
		$query	= GenQuery('links','a','device','','power',array("power"),array('>'),array('0') );
	}else{
		$query	= GenQuery('links','a','device','avg desc','power',array("power"),array('>'),array('0') );
	}
	$res	= @DbQuery($query,$link);
	if($res){
		$row = 0;
		while( ($d = @DbFetchRow($res)) ){
			if ($row % 2){$bg = "txta"; $bi = "imga";}else{$bg = "txtb"; $bi = "imgb";}
			$row++;
			$pbar = Bar($d[2]/1000,1000);
			$ud = rawurlencode($d[0]);
			echo "<tr class=\"$bg\"><th class=\"$bi\">\n";
			echo "<a href=Devices-Status.php?dev=$ud><img src=\"img/dev/".$dico[$d[0]].".png\"></a><br><b>$d[0]</b></th>\n";
			echo "<th>$d[1]</th><td>$pbar ".($d[2]/1000)." W</td></tr>\n";
			if($row == $lim){break;}
		}
	}else{
		print @DbError($link);
	}
?>
</table>
<table class="content" >
<tr class="<?=$modgroup[$self]?>2"><td><?=$query?></td></tr>
</table>

</td></tr></table>
<?
}

if ( in_array("ust",$rep) ){
?>
<h2>Device <?=$updlbl?></h2>
<table class="content"><tr class="<?=$modgroup[$self]?>2">
<th width=33%><img src="img/32/clock.png"><br><?=$timlbl?></th>
<th><img src="img/32/eyes.png"><br><?=$fislbl?> <?=$laslbl?></th>
<?

	if($ord){
		ksort ($devup);
	}else{
		krsort ($devup);
	}
	$row = 0;
	foreach ( array_keys($devup) as $d ){
		if ($row % 2){$bg = "txta"; $bi = "imga";}else{$bg = "txtb"; $bi = "imgb";}
		$row++;
		$devup[$d]['fs'] = isset($devup[$d]['fs']) ? $devup[$d]['fs'] : 0;
		$devup[$d]['ls'] = isset($devup[$d]['ls']) ? $devup[$d]['ls'] : 0;
		if(!$devup[$d]['fs']){$devup[$d]['fs'] = 0;}
		if(!$devup[$d]['ls']){$devup[$d]['ls'] = 0;}
		$fbar = Bar($devup[$d]['fs'],100000);
		$lbar = Bar($devup[$d]['ls'],1);
		$fd   = rawurlencode(date("m/d/Y H:i:s",$d));
		echo "<tr class=\"$bg\"><th class=\"$bi\">\n";
		echo date($datfmt,$d)."</th>\n";
		echo "<td>$fbar <a href=\"Devices-List.php?ina=firstseen&opa==&sta=$fd\">".$devup[$d]['fs']."</a>\n";
		echo "$lbar <a href=\"Devices-List.php?ina=lastseen&opa==&sta=$fd\">".$devup[$d]['ls']."</a></td></tr>\n";
		if($row == $lim){break;}
	}
	?>
</table>
<table class="content" >
<tr class="<?=$modgroup[$self]?>2"><td><?=$row?> <?=$updlbl?>, <?=$ndev?> devices total</td></tr>
</table>
	<?
}

}
include_once ("inc/footer.php");
?>
