<?
/*
#============================================================================
# Program: System-NeDi.php
# Programmer: Remo Rickli
#
# DATE		COMMENT
# -----------------------------------------------------------
# 10/25/09	initial version, based on B. Eschlwech's contribution
*/

include_once ("inc/header.php");

$_POST = sanitize($_POST);

$mod = isset($_POST['mod']) ? $_POST['mod'] : "h";

$usr = isset($_POST['usr']) ? $_POST['usr'] : "";
$psw = isset($_POST['psw']) ? $_POST['psw'] : "";

$oui = isset($_POST['oui']) ? "checked" : "";
$rte = isset($_POST['rte']) ? "checked" : "";
$dip = isset($_POST['dip']) ? "checked" : "";
$dbg = isset($_POST['dbg']) ? "checked" : "";

$fqd = isset($_POST['fqd']) ? "checked" : "";
$kip = isset($_POST['kip']) ? "checked" : "";
$ndv = isset($_POST['ndv']) ? "checked" : "";
$vrb = isset($_POST['vrb']) ? "checked" : "";

$bup = isset($_POST['bup']) ? $_POST['bup'] : "";

$opt = isset($_POST['opt']) ? $_POST['opt'] : "-";
$tst = isset($_POST['tst']) ? "checked" : "";

$cmd = "$nedipath/nedi.pl";
if($mod == "i"){
	$cmd .= " -i $usr $psw";
}elseif($mod == "y"){
	$cmd .= " -y";
}elseif($mod == "d"){
	if($vrb){
		$cmd .= " -v";
	}
	if($dbg){
		$cmd .= " -d";
	}

	if($dip){
		$cmd .= " -p";
	}
	if($rte){
		$cmd .= " -r";
	}
	if($oui){
		$cmd .= " -o";
	}

	if($fqd){
		$cmd .= " -F";
	}
	if($kip){
		$cmd .= " -I";
	}
	if($ndv){
		$cmd .= " -N";
	}

	if($bup == "b"){
		$cmd .= " -b";
	}elseif($bup == "B"){
		$cmd .= " -B";
	}

	if($opt !="-" and $tst){
		$cmd .= " -t $opt";
	}elseif($opt !="-"){
		$cmd .= " -a $opt";
	}

}elseif($opt !="-" and $mod == "s"){
	if($vrb){
		$cmd .= " -v";
	}
	if($dbg){
		$cmd .= " -d";
	}
	$cmd .= " -s $opt";
}else{
	$cmd .= " --help";
}
?>
<script language="JavaScript">
<!--
chg = 0;

function ConfirmSubmit() {

	if (document.nedi.mod[4].checked == true){
		if( confirm('NeDi <?=$resbtn?>????') ){
			document.nedi.submit();
		}else{
			return;
		}
	}
	document.nedi.submit();
}
//-->
</script>

<h1>Run NeDi</h1>
<form name="nedi" action="<?=$self?>.php" method="post">
<table class="content">
<tr class="<?=$modgroup[$self]?>1">
<th width="80" class="<?=$modgroup[$self]?>1"><a href="<?=$self?>.php"><img src="img/32/<?=$selfi?>.png"></a></th>

<td valign="top">

<h3>
<input type="radio" name="mod" value="d" <?=($mod == "d")?"checked":""?>> Discover 
<input type="radio" name="mod" value="s" <?=($mod == "s")?"checked":""?>> Scan
</h3>
<table>
	<tr>
	<td><input type="text" name="opt" value="<?=$opt?>" size="12" onfocus="select();" title="seed / fingerprint options"></td>
	<td><input type="checkbox" name="vrb" <?=$vrb?> title="show lots of info">Verbose</td>
	<td><input type="checkbox" name="dbg" <?=$dbg?> title="show debug info"> Debug</td>
	<td><input type="checkbox" name="tst" <?=$tst?> title="only testing, no write"> Test</td>
	</tr>

	<tr>
	<td><SELECT size="1" name="bup" >
	<OPTION VALUE=""><?=$cfglbl?>
	<OPTION VALUE="b" <?=($bup == "b")?"selected":""?> >DB Backup
	<OPTION VALUE="B" <?=($bup == "B")?"selected":""?> >DB & File
	</SELECT></td>
	<td><input type="checkbox" name="dip" <?=$dip?> title="use discovery protocols"> LLDP/CDP</td>
	<td><input type="checkbox" name="rte" <?=$rte?> title="use routing tables"> Route</td>
	<td><input type="checkbox" name="oui" <?=$oui?> title="use ouidev from nedi.conf"> OUI</td>
	</tr>

	<tr>
	<td></td>
	<td><input type="checkbox" name="ndv" <?=$ndv?> title="keep devices in Nodes"> Node Dev</td>
	<td><input type="checkbox" name="kip" <?=$kip?> title="don't search better device IP"> Keep IP</td>
	<td><input type="checkbox" name="fqd" <?=$fqd?> title="don't strip domains from devices"> FQDN</td>
	</tr>
</table>

</td><td valign="top">

<h3>Info</h3>
<table>
	<tr><td>help</td><td><input type="radio" name="mod" value="h" <?=($mod == "h")?"checked":""?>></td>
	<tr><td>.def <?=$lstlbl?></td><td><input type="radio" name="mod" value="y" <?=($mod == "y")?"checked":""?>></td></tr>
</table>

</td><td valign="top">

<h3><input type="radio" name="mod" value="i" <?=($mod == "i")?"checked":""?>> Init</h3>
<table>
	<tr><td>User:</td><td><input type="text" name="usr" size="10"></td>
	<tr><td>Pass:</td><td><input type="password" name="psw" size="10"></td></tr>
</table>

</td>

<th><input type="button" name="go" value="<?=$cmdlbl?>" onClick="ConfirmSubmit();"></th>

</tr></table>
</form>

<h3><?=$cmd?></h3>
<div class="textpad code txta" name="out">
<?
ob_end_flush();
echo system($cmd);
#echo system("$cmd 2>&1");
?>
</div><br>

<?

include_once ("inc/footer.php");
?>
