<?php
#============================================================================
# Program: drawrrd.php
# use GET option d=1 to debug output, if you encounter problems!
#============================================================================

# Disables RRD checks for faster processing
$safe = 0;

include_once ("libgraph.php");
include_once ("libmisc.php");
ReadConf('usr');

session_start(); 
if( !$rrdcmd or !$_SESSION['group'] ){
	die;
}

$_GET = sanitize($_GET);
$typ = isset($_GET['t']) ? $_GET['t'] : "";
$gsz = isset($_GET['s']) ? $_GET['s'] : "";
$sta = isset($_GET['a']) ? $_GET['a'] : "";
$end = isset($_GET['e']) ? $_GET['e'] : "";

include_once ("../languages/$_SESSION[lang]/gui.php");

$debug = isset( $_GET['d']) ? "Debugging" : "";
$draw	= "";

if($typ == 'cpu'){
	$tit = 'CPU Load';
	$rrd = "$nedipath/rrd/" . rawurlencode($_GET['dv']) ."/system.rrd";
	if($safe){$debug = ( file_exists("$rrd") )?"":"RRD $rrd not found!";}
	$draw .= "DEF:cpu=$rrd:cpu:AVERAGE AREA:cpu#cc8855 ";
	$draw .= "CDEF:cpu2=cpu,1.1,/ AREA:cpu2#dd9966 ";
	$draw .= "CDEF:cpu3=cpu,1.2,/ AREA:cpu3#eeaa77 ";
	$draw .= "CDEF:cpu4=cpu,1.3,/ AREA:cpu4#ffbb88 ";
	$draw .= "LINE2:cpu#995500:\"%\" ";
}elseif($typ == 'mem'){
	$tit = 'Main Memory';
	$rrd = "$nedipath/rrd/" . rawurlencode($_GET['dv']) ."/system.rrd";
	if($safe){$debug = ( file_exists("$rrd") )?"":"RRD $rrd not found!";}
	$draw .= "DEF:memcpu=$rrd:memcpu:AVERAGE AREA:memcpu#bbbb77 ";
	$draw .= "CDEF:memcpu2=memcpu,1.1,/ AREA:memcpu2#cccc88 ";
	$draw .= "CDEF:memcpu3=memcpu,1.2,/ AREA:memcpu3#dddd99 ";
	$draw .= "CDEF:memcpu4=memcpu,1.3,/ AREA:memcpu4#eeeeaa ";
	$draw .= "LINE2:memcpu#666600:\"Bytes $frelbl\" ";
}elseif($typ == 'tmp'){
	$tit = "$tmplbl";
	$rrd = "$nedipath/rrd/" . rawurlencode($_GET['dv']) ."/system.rrd";
	if($safe){$debug = ( file_exists("$rrd") )?"":"RRD $rrd not found!";}
	$draw .= "DEF:temp=$rrd:temp:AVERAGE AREA:temp#7788bb  ";
	$draw .= "CDEF:temp2=temp,1.1,/ AREA:temp2#8899cc ";
	$draw .= "CDEF:temp3=temp,1.2,/ AREA:temp3#99aadd ";
	$draw .= "CDEF:temp4=temp,1.3,/ AREA:temp4#aabbee ";
	$draw .= "LINE2:temp#224488:\"$grdlbl Celsius\" ";
	if ($_SESSION['gfar']){$draw .= "CDEF:far=temp,1.8,*,32,+ LINE2:far#006699:\"$grdlbl Fahrenheit\" ";}
}elseif($typ == 'cuv'){
	$tit = ($_GET['if'][0])?$_GET['if'][0]:"Custom";
	$u   = ($_GET['if'][1])?$_GET['if'][1]:"-";	
	$cuds= preg_replace('/[^a-zA-Z0-9]/', '', strtolower($tit) );
	$rrd = "$nedipath/rrd/" . rawurlencode($_GET['dv']) ."/system.rrd";
	if($safe){$debug = ( file_exists("$rrd") )?"":"RRD $rrd not found!";}
	$draw .= "DEF:$cuds=$rrd:$cuds:AVERAGE AREA:$cuds#88bb77 ";
	$draw .= "CDEF:${cuds}2=$cuds,1.1,/ AREA:${cuds}2#99cc88 ";
	$draw .= "CDEF:${cuds}3=$cuds,1.2,/ AREA:${cuds}3#aadd99 ";
	$draw .= "CDEF:${cuds}4=$cuds,1.3,/ AREA:${cuds}4#bbeeaa ";
	$draw .= "LINE2:$cuds#668800:\"$u\" ";
}elseif($typ == 'ttr'){
	$rrd = "$nedipath/rrd/top.rrd";
	if($safe){$debug = ( file_exists("$rrd") )?"":"RRD $rrd not found!";}
	$tit = "Total Edge $trflbl";
	if ($_SESSION['gbit']){
		$draw .= "DEF:tinoct=$rrd:tinoct:AVERAGE ";
		$draw .= "CDEF:btinoct=tinoct,8,* AREA:btinoct#0088ee:\"In Mbit/s\" ";
		$draw .= "DEF:totoct=$rrd:totoct:AVERAGE ";
		$draw .= "CDEF:btotoct=totoct,8,* LINE2:btotoct#00ee88:\"Out Mbit/s\l\" ";
	}else{
		$draw .= "DEF:tinoct=$rrd:tinoct:AVERAGE AREA:tinoct#0088cc:\"In Mbyte/s\" ";
		$draw .= "DEF:totoct=$rrd:totoct:AVERAGE LINE2:totoct#000066:\"Out Mbyte/s\l\" ";
	}
}elseif($typ == 'ter'){
	$rrd = "$nedipath/rrd/top.rrd";
	if($safe){$debug = ( file_exists("$rrd") )?"":"RRD $rrd not found!";}
	$tit = "Total Non-Wlan $errlbl";
	$draw .= "DEF:tinerr=$rrd:tinerr:AVERAGE AREA:tinerr#880000:\"In #/s\" ";
	$draw .= "DEF:toterr=$rrd:toterr:AVERAGE LINE2:toterr#886600:\" Out #/s\l\" ";
}elseif($typ == 'nod'){
	$rrd = "$nedipath/rrd/top.rrd";
	if($safe){$debug = ( file_exists("$rrd") )?"":"RRD $rrd not found!";}
	$tit = 'Total Nodes';
	$draw .= "DEF:tnodls=$rrd:tnodls:AVERAGE AREA:tnodls#666666 ";
	$draw .= "DEF:tnodfs=$rrd:tnodfs:AVERAGE AREA:tnodfs#44aa00:\"$fislbl\" ";
	$draw .= "LINE2:tnodls#aaaaaa:\"$laslbl\l\" ";
}elseif($typ == 'tpw'){
	$rrd = "$nedipath/rrd/top.rrd";
	if($safe){$debug = ( file_exists("$rrd") )?"":"RRD $rrd not found!";}
	$tit = 'Total PoE';
	$draw .= "DEF:tpower=$rrd:tpower:AVERAGE AREA:tpower#bbaa00 ";
	$draw .= "CDEF:tpower2=tpower,1.1,/ AREA:tpower2#ccbb00 ";
	$draw .= "CDEF:tpower3=tpower,1.2,/ AREA:tpower3#ddcc00 ";
	$draw .= "CDEF:tpower4=tpower,1.3,/ AREA:tpower4#eedd00 ";
	$draw .= "LINE2:tpower#aa9900:\"Watt\" ";
}elseif($typ == 'tdi'){
	$rrd = "$nedipath/rrd/top.rrd";
	if($safe){$debug = ( file_exists("$rrd") )?"":"RRD $rrd not found!";}
	$tit = 'Disabled Interfaces';
	$draw .= "DEF:tdisif=$rrd:tdisif:AVERAGE LINE2:tdisif#cc4400:\"#\" ";
}elseif($typ == 'mon'){
	$rrd = "$nedipath/rrd/top.rrd";
	if($safe){$debug = ( file_exists("$rrd") )?"":"RRD $rrd not found!";}
	$tit = "Device $avalbl";
	$draw .= "DEF:monok=$rrd:monok:AVERAGE AREA:monok#008844:\"Up\" ";
	$draw .= "DEF:monal=$rrd:monal:AVERAGE STACK:monal#884400:\"Down\l\" ";
}elseif($typ == 'msg'){
	$rrd = "$nedipath/rrd/top.rrd";
	if($safe){$debug = ( file_exists("$rrd") )?"":"RRD $rrd not found!";}
	$tit = "$msglbl / " .intval($rrdstep/3600)."h";
	$draw .= "DEF:msg50=$rrd:msg50:AVERAGE AREA:msg50#44cc44:\"".substr($mlvl[50],0,4)."\" ";
	$draw .= "DEF:msg100=$rrd:msg100:AVERAGE STACK:msg100#4444cc:\"".substr($mlvl[100],0,4)."\" ";
	$draw .= "DEF:msg150=$rrd:msg150:AVERAGE STACK:msg150#cc44cc:\"".substr($mlvl[150],0,4)."\" ";
	$draw .= "DEF:msg200=$rrd:msg200:AVERAGE STACK:msg200#ccbb44:\"".substr($mlvl[200],0,4)."\" ";
	$draw .= "DEF:msg250=$rrd:msg250:AVERAGE STACK:msg250#cc4444:\"".substr($mlvl[250],0,4)."\l\" ";
}elseif($typ == 'trf' or $typ == 'err' or $typ == 'brc'){
	foreach ($_GET['if'] as $i){
		$rrd[$i] = "$nedipath/rrd/" . rawurlencode($_GET['dv']) . "/" . rawurlencode($i) . ".rrd";
		if($safe){$debug = ( file_exists("$rrd[$i]") )?"":"RRD $rrd[$i] not found!";}
	}
	list($draw,$tit) = GraphTraffic($rrd,$typ);
}
$opts = GraphOpts($gsz,$sta,$end,$tit,0);

if($debug){
	echo "<b>$debug</b>";
	echo "<pre>$rrdcmd graph - -a PNG $opts\n\t$draw</pre>";
}else{
	header("Content-type: image/png");
	passthru("$rrdcmd graph - -a PNG $opts $draw");
}

?>
