#============================================================================
#
# Program: libmon.pl
# Programmer: Remo Rickli
#
# -> Functions for monitoring <-
#
#============================================================================
package mon;

#===================================================================
# Send SMS
# Requires sms_client with default service set properly
#===================================================================
sub SendSMS {
	&db::ReadUser(8);
	print " smsing \"$_[0]\" to:" if $main::opt{v};
	my $m = 0;
	foreach my $u ( keys %main::usr ){
		if($main::usr{$u}{ph}){
			print " $u" if $main::opt{v};
			# send the sms
			$m++ if !system "sms_client $main::usr{$u}{ph} \"$_[0]\" >/dev/null";
		}
	}
	print " \n" if $main::opt{v};
	return $m;
}

#===================================================================
# Send Mail
#===================================================================
sub SendMail {

	use Net::SMTP;
	
	undef (%main::usr);
	&db::ReadUser(8);

	print " mailing \"$_[0]\" to:" if $main::opt{v};

	my $m = 0;
	foreach my $u ( keys %main::usr ){
		if($main::usr{$u}{ml}){
			print " $u" if $main::opt{v};
			
			# send the message
			my $message = Net::SMTP->new($misc::smtpserver) || return "(Can't talk to SMTP server $misc::smtpserver!)";
			$message->mail($misc::mailfrom);
			$message->to($main::usr{$u}{ml}) || return "failed to send to $main::usr{$u}{ml}!";
			$message->data();
			$message->datasend("To: $main::usr{$u}{ml}\n");
			$message->datasend("From: $misc::mailfrom\n");
			$message->datasend("Subject: $_[0]\n");
			$message->datasend("\n");
			$message->datasend("$_[1]\n");
			$message->dataend();
			$message->quit;
			$m++;
		}
	}
	print " \n" if $main::opt{v};
	return $m;
}


1;
